=== tools/asistant/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pasistant -XBLD=$(BLD)
clean:
	gnat clean -Pasistant
