=== tools/gnatcheck/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatcheck -XBLD=$(BLD)
clean:
	gnat clean -Pgnatcheck
