=== tools/gnatelim/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatelim -XBLD=$(BLD)
clean:
	gnat clean -Pgnatelim
