=== tools/gnatmetric/Makefile ===
include ../../Makefile.stub
BLD=prod

default:
	gnat make -Pgnatmetric -XBLD=$(BLD)
clean:
	gnat clean -Pgnatmetric
