=== debian/changelog ===
asis (2014-4) unstable; urgency=medium

  * debian/patches/report_unexpected_gnat_version.diff: delete; caused
    ASIS to report a "wrong" version of GNAT if Gnatvsn.Gnat_Version_String
    returned a string lacking a "(" in it.
  * debian/patches/weak_version_check.diff: new.  Do not check the version
    string of the compiler embedded in the tree files against
    Gnatvsn.Gnat_Version_String.  Checking only the tree version number
    (Tree_IO.ASIS_Version_Number, in libgnatvsn) is sufficient.
    Closes: #765467.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue, 21 Oct 2014 01:13:57 +0200

asis (2014-3) unstable; urgency=medium

  * Extra priority: asis-programs depends on gnatcoll, asis-dev on gnatvsn-dev.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 06 Oct 2014 17:44:58 +0200

asis (2014-2) unstable; urgency=medium

  * control: fix typo and version: asis-programs Recommends: libaunit-dev.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 04 Oct 2014 21:02:58 +0200

asis (2014-1) unstable; urgency=medium

  [Nicolas Boulenguez]
  * Repackage without GFDL documentations.
  * copyright: upstream license change from GPL 2 -> 3.
  * Depend on gnatcoll, xmlada and gnatprj to build most executables.
  * Manual pages: update doc references, remove authors (see man-pages(7)).
  * Replace confusing and buggy get-orig-source with detailed README.source.
  * Priority: -dev extra because Depends: libgnatvsn-dev.
  * Avoid a GCC version check (redundant ant triggers #759038.
  * Move -dbg to priority extra to please lintian.
  * Standards-Version: 3.9.6 (no changes).

  [Ludovic Brenta]
  * New upstream release.  Package renamings per Debian Policy for Ada:
    libasis2013{,-dev} -> libasis2014{,-dev}
  * debian/patches/remove_ada_tree_predicate.diff: refresh.
  * debian/rules (gnat2xsd): removed upstream, do not build anymore.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 04 Oct 2014 15:43:25 +0200

asis (2013-1) unstable; urgency=low

  [Nicolas Boulenguez]
  * New upstream version. Relies on gnat-4.9. Gnatsync removed.
    Per policy, 3 package renamings, no Replaces/Conflicts.
    Bug #642980 is closed in gnat-4.8, work-around removed.
    remove_ada_tree_predicate.diff: predicate misused, 4.9 detects it.
  * control: -dev Suggests asis-doc, not libasis-doc.
  * rules: get-orig-source may be called outside the source directory.
    Remove run times assertions and style checking.
    Run-tests target obsoleted by sadt from devscripts.
  * Standards-Version: 3.9.5 (no changes).

  [Ludovic Brenta]
  * Do not build gnatcheck anymore as it requires gnatcoll which is not
    yet packaged.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 01 May 2014 13:16:59 +0200
