=== tools/gnat2xml/Makefile ===
--- 
+++ 
@@ -1,12 +1,3 @@
-include ../../Makefile.stub
-BLD=prod
-
-default: all
-
-clean:
-	gnat clean -Pgnat2xml
-	gnat clean -Pxml2gnat
-
 # Make file for building gnat2xml and related tools, and for running tests.
 
 # Targets:
@@ -20,15 +11,42 @@
 #    changes in the schema output by gnat2xsd (after checking that those
 #    changes are correct).
 
+include ../../Makefile.stub
+BLD=prod
+
 TIME=
 #TIME=/usr/bin/time -f '%e seconds = %E'
 
-EXTRA_GNATMAKE_FLAGS=
-GNATMAKE=$(TIME) gnatmake -g -k
-#GNAT2XML_FLAGS=-v -dc
+GPRBUILD=$(TIME) gprbuild -g
 GNAT2XML_FLAGS=-q
 GNATPP=$(TIME) gnatpp --pp-old -rnb -q
-# -rnb = "replace no backup"
+
+# ==================================================== build
+
+default: all
+
+all:
+	@# Generate two XML Schemas, ada-schema.xsd.new is verbose,
+	@# and ada-schema.compact.xsd.new is compact.
+	./gnat2xsd > ada-schema.xsd.new
+	./gnat2xsd --compact > ada-schema.compact.xsd.new
+
+.PHONY: update-schema
+update-schema:
+	rm -f ada-schema.xsd.old
+	mv ada-schema.xsd ada-schema.xsd.old
+	mv ada-schema.xsd.new ada-schema.xsd
+	rm -f ada-schema.compact.xsd.old
+	mv ada-schema.compact.xsd ada-schema.compact.xsd.old
+	mv ada-schema.compact.xsd.new ada-schema.compact.xsd
+
+# ==================================================== clean
+
+clean:
+	rm -rf obj stage  ada-schema.*new
+
+# ==================================================== test
+
 
 # Test gnat2xsd by comparing its output against expected results.
 # Test gnat2xml by validating its output against the schema using xmllint.
@@ -36,9 +54,6 @@
 test-gnat2xml: all
 	@echo "Doing  test-gnat2xml"
 	cd test ; rm -rf actual.compact actual.verbose ; mkdir -p actual.compact actual.verbose
-	@#???cd test ; $(GNATMAKE) -gnat2012 -gnatct *.ad[sb]
-	@#???cd test ; ../gnat2xml -c --compact $(GNAT2XML_FLAGS) -t -mactual.compact *.ad[sb]
-	@#???cd test ; $(GNATMAKE) -gnat2012 *.ad[sb] --GCC="../gnat2xml --compact $(GNAT2XML_FLAGS) -t -mactual.compact"
 	cd test ; ../gnat2xml --compact $(GNAT2XML_FLAGS) -mactual.compact *.ad[sb]
 	cd test ; ../gnat2xml    $(GNAT2XML_FLAGS) -mactual.verbose *.ad[sb]
 
@@ -80,7 +95,7 @@
 	chmod -w stage/1/generated_ada/*
 
 	cp -p boot.gpr stage/1/generated_ada
-	cd stage/1/generated_ada ; $(GNATMAKE) -P boot.gpr -p -XBLD=debug
+	cd stage/1/generated_ada ; $(GPRBUILD) -P boot.gpr -p -XBLD=debug
 	cd stage/1/generated_ada ; ./gnat2xsd > ada-schema.xsd.new
 	cd stage/1 ; ./generated_ada/gnat2xml $(GNAT2XML_FLAGS) -mxmlxml *.ads *.adb
 
@@ -136,7 +151,7 @@
 	$(TIME) ./gnat2xml-gnat2tokens stage/1/*.ad[sb] > stage/tokens/tokens.out
 	gnatchop -w stage/tokens/tokens.out stage/tokens
 	cp -p tokens.gpr stage/tokens
-	cd stage/tokens ; $(GNATMAKE) -P tokens.gpr -p -XBLD=debug
+	cd stage/tokens ; $(GPRBUILD) -P tokens.gpr -p -XBLD=debug
 	cd stage/tokens ; ./gnat2xsd > ../ada-schema.xsd.new
 
 	@# Check that the translated version of gnat2xsd behaves the same as the
@@ -178,7 +193,7 @@
 	-cd gnatutil ; wc `cat ada-files.list ` | tail -1
 	-grep '^................................................................................ ' gnatutil.diff | wc
 	cp -p gnatutil.gpr gnatutil/generated_ada
-	cd gnatutil/generated_ada ; $(GNATMAKE) -f -p -P gnatutil.gpr -XBLD=debug
+	cd gnatutil/generated_ada ; $(GPRBUILD) -f -p -P gnatutil.gpr -XBLD=debug
 
 .PHONY: test-buffers
 test-buffers:
@@ -195,64 +210,6 @@
 
 .PHONY: test
 test: all debug test-buffers test-gnat2xml test-xml2gnat test-gnat2tokens do-self-rep-basic_decl.ads do-regen-ada-basic_decl.ads
-
-.PHONY: all
-all: compile1 ada_trees-factory.ads ada_trees-factory.adb compile2
-
-# Compile things that don't depend on the generated factory, including the
-# factory-generating program.
-.PHONY: compile1
-compile1:
-	#$(GNATMAKE) $(EXTRA_GNATMAKE_FLAGS) -x -P gnat2xml.gpr -I../../../tools/tool_utils -I../../../../tools/tool_utils -I../../../gnat -I../../../../gnat -p
-	$(GNATMAKE) $(EXTRA_GNATMAKE_FLAGS) -P gnat2xml.gpr -p -XBLD=$(BLD)
-
-	@# Generate two XML Schemas, ada-schema.xsd.new is verbose,
-	@# and ada-schema.compact.xsd.new is compact.
-	./gnat2xsd > ada-schema.xsd.new
-	./gnat2xsd --compact > ada-schema.compact.xsd.new
-
-ada_trees-generate_factory: compile1
-
-# Depend on the executable ada_trees-generate_factory; if the structure
-# of ASIS elements changes, it will be rebuilt by compile1, which will
-# trigger regeneration of the factory.
-ada_trees-factory.ads ada_trees-factory.adb: ada_trees-generate_factory
-	@# Generate ada_trees-factory.ad[sb]
-	rm -rf ada_trees-factory.ads ada_trees-factory.adb xml self_rep generated_ada
-	./ada_trees-generate_factory
-	#???Following is an attempt to reformat the factory. It doesn't work
-	#because gnat2xml compiles the factory, and it can't find "with"ed
-	#units. This will have to wait until we've more fully integrated with
-	#ASIS.
-	#mkdir -p xml
-	#$(GNATMAKE) -gnat2012 -gnatct -P xml2gnat.gpr ada_trees-factory.adb
-	#./gnat2xml -mxml ada_trees-factory.ads ada_trees-factory.adb
-	#./xml2gnat ada_trees-factory.ads ada_trees-factory.adb
-	#cd generated_ada ; cp -p ada_trees-factory.ads ada_trees-factory.adb ..
-
-# Compile things that depend on the generated factory.
-.PHONY: compile2
-compile2: ada_trees-factory.ads ada_trees-factory.adb
-	$(GNATMAKE) $(EXTRA_GNATMAKE_FLAGS) -P xml2gnat.gpr -p -XBLD=$(BLD)
-
-.PHONY: pp
-pp:
-	rm -rf pp.in pp.out
-	mkdir -p pp.in
-	cp -p stage/3/*.ad[sb] pp.in
-	chmod +w pp.in/*
-	cp -pr pp.in pp.out
-	-cd pp.out ; $(GNATPP) *.ad[sb]
-	-diff pp.in pp.out | wc
-
-.PHONY: update-schema
-update-schema:
-	rm -f ada-schema.xsd.old
-	mv ada-schema.xsd ada-schema.xsd.old
-	mv ada-schema.xsd.new ada-schema.xsd
-	rm -f ada-schema.compact.xsd.old
-	mv ada-schema.compact.xsd ada-schema.compact.xsd.old
-	mv ada-schema.compact.xsd.new ada-schema.compact.xsd
 
 ################
