=== debian/changelog ===
asis (2015-1) unstable; urgency=medium

  * New upstream version, built with gnat-6.
    Rename -lib and -dev packages because of Ada policy.
  * Drop obsolete dependency on libgnatprj.
  * Disable tools with incomplete sources (removing dependency on XMLAda).
    gcc-6.diff: adapt ASIS-GPL-2015 to GCC-6 instead of GNAT-GPL-2015.
  * Switch to gprbuild as gnatmake does not support projects anymore.
  * Switch from manual -dbg packages to automatic -dbgsym packages.
  * Enable all hardening flags.
  * Ensure deterministic timestamps in ALI files.
  * watch, README.source: use Adacore redirector.
  * Standards-Version: 3.9.8 (no changes), drop generated XS-Testsuite.
  * Raise priority to optional to follow ftp-master overrides.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 30 Apr 2016 16:41:45 +0200
