=== debian/control ===
Source: asis
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Xavier Grave <xavier.grave@ipno.in2p3.fr>,
 Nicolas Boulenguez <nicolas@debian.org>
Section: libdevel
Priority: extra
Standards-Version: 3.9.8
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-6,
 libgnatvsn6-dev,
# gprbuild handling gnat-6
 gprbuild (>= 2015-2),
# Some tools require gnatcoll.
 libgnatcoll1.7-dev,
# Disabled as long as tools/gnat2xml/gnat2xml.gpr is not used.
# libxmlada-input-sources6-dev,
# libxmlada-sax6-dev,
# libxmlada-dom6-dev,
# dh-ada-library knowing that -dbg packages are obsolete.
 dh-ada-library (>= 6.7)
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.asis
Vcs-Mtn: www.ada-france.org org.debian.asis
Homepage: http://libre.adacore.com/libre/tools

Package: libasis2015-dev
Architecture: any
Depends: ${ada:Depends}, ${misc:Depends}
Suggests: asis-doc
Description: Ada Semantic Interface Specification (ASIS) headers and libraries
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package lets you build ASIS applications with GNAT.

Package: asis-programs
Architecture: any
Section: devel
Priority: optional
Depends: gnat, gnat-6, ${shlibs:Depends}, ${misc:Depends}
Recommends: libaunit3.7.2-dev
Description: Ada Semantic Interface Specification (ASIS) example programs
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
  * asistant is an interactive command-line tool to explore the ASIS parse tree
    of a program.
  * gnatcheck verifies the conformance of source text to coding conventions
  * gnatelim finds out unused subprograms and eliminates them.
  * gnatmetric calculates metrics such as code complexity.
  * gnatpp is a pretty-printer which reformats Ada source text according to
    a default or user-specified style guide.
  * gnatstub generates an empty but compilable body for a given specification.
  * gnattest creates AUnit test skeletons and harness for a project
    (gnattest requires the libaunit development package to be installed)

Package: libasis2015
Architecture: any
Section: libs
Priority: optional
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: gnat, gnat-6, ${shlibs:Depends}, ${misc:Depends}
Description: Ada Semantic Interface Specification (ASIS) runtime library
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the libraries necessary to execute ASIS programs.

Package: asis-doc
Architecture: all
Section: doc
Priority: optional
Depends: ${misc:Depends}
Suggests: gnat
Description: Ada Semantic Interface Specification (ASIS) documentation
 ASIS (Ada Semantic Interface Specification) lets you develop applications
 to walk through the sources of your Ada programs and examine the semantic
 constructs.
 .
 This package contains the tutorial, news and examples, but not the
 extensive manuals until their license has been clarified.
