=== debian/watch ===
version=3
opts=filenamemangle=s/^.*download=//,dversionmangle=s/^.*\.// \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=adacore/asis \
.*asis-gpl-(\d{4})-src\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
